!$Id: vmSpFlat.prg,v 1.6 2005/02/28 13:46:35 cizzo Exp $
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!COPYRIGHT (c) 1999 European Southern Observatory
!LICENSE
!
!PROJECT:   VLT Data Flow System
!AUTHOR:    R.Palsa, C.Izzo, P.Sartoretti - ESO/DMD/DPG
!SUBSYSTEM: VIMOS Instrument Pipeline
!PURPOSE:   MIDAS interface procedure for pipeline recipe vmSpFlat.
!
!$Name: vmcdb-2_6_0 $
!$Revision: 1.6 $
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

define/local recipeName/c/1/20 "vmspflat"

define/local resultFrames/c/1/150 "{P1}"
define/local inputFrames/c/1/150 "{P2}"
define/local calibData/c/1/150 "{P3}"
define/local recipeSpecs/c/1/150 " {recipeName} {recipeName}.sof"

define/local didPath/c/1/200 " -I"
define/local didList/c/1/200 " -D"
define/local pafList/c/1/200 " -p qc*.paf"

define/local proPrefixOption/c/1/20 " --output-prefix="
define/local logFileOption/c/1/20 " --log-file="
define/local pathOption/c/1/20 " --recipe-dir="

define/local pathLib/c/1/60 "$PIPE_HOME/vimos"
define/local proDir/c/1/60 ""
define/local proPrefix/c/1/60 ""
define/local logFile/c/1/60 ""

define/local cmdLine/c/1/400 " " all
define/local line/c/1/400 " " all

define/local pos/i/1/1 0

define/local fid/i/1/2 0 all
define/local sid/i/1/2 0 all


log/rec {recipeName} IN


pos = m$indexb(resultFrames, "/") - 1

proDir = resultFrames(1:{pos})
pos = pos + 2
proPrefix = resultFrames({pos}:)
logFile = proPrefix // ".log"

!-------------------------------------------------------
! The following piece of code is a TEMPORARY PATCH
! to get the RAW and CALIB tags into the set of frames
! file. It has to stay there until the RBS has been
! patched and will be removed afterwards
!-------------------------------------------------------
open/file {recipeName}.sof write sid
if sid(1) .lt. 0 then
    return 1
endif

open/file {inputFrames} read fid
if fid(1) .lt. 0 then
    return 1
endif

raw_loop:
    read/file {fid(1)} line
    if fid(2) .gt. 0 then
        fid(2) = fid(2) + 1
        line({fid(2)}:) = " RAW"
        write/file {sid(1)},key line
        goto raw_loop
    endif
close/file {fid(1)}

if calibData .ne. "?" then
    open/file {calibData} read fid
    if fid(1) .lt. 0 then
        return 1
    endif

cal_loop:
    read/file {fid(1)} line
    if fid(2) .gt. 0 then
        fid(2) = fid(2) + 1
        line({fid(2)}:) = " CALIB"
        write/file {sid(1)},key line
        goto cal_loop
    endif

    close/file {fid(1)}
endif
close/file {sid(1)}

cmdLine = "$CPLDIR/bin/esorex --output-dir=" // proDir -
          // proPrefixOption // proPrefix // pathOption // pathLib -
          // logFileOption // logFile // recipeSpecs

outputi = m$system(cmdLine)
if outputi(1) .ne. 0 then
  return 1
endif

if m$exist("qc0000.paf") .eq. 1 then
  didPath(5:) = m$symbol("INS_ROOT") // "/SYSTEM/Dictionary"

  didList(5:) = "ASM,CCDDCS,DPR,FCDDCS,GEN,OBS,PRIMARY-FITS,PRO," // -
                "VIMOS_OS,VIMOS_ICS,VIMOS_MPS,VIMOS_DRS,TPL"

  cmdLine = "QC1LogWriter -s VIMOS" // didPath // didList // pafList

  outputi = m$system(cmdLine)
  if outputi(1) .ne. 0 then
    return 1
  endif
endif

log/rec {recipeName} OUT
